Index: uspace/srv/fs/ext4fs/ext4fs.c
===================================================================
--- uspace/srv/fs/ext4fs/ext4fs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/ext4fs/ext4fs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -42,5 +42,4 @@
 #include <task.h>
 #include <ipc/services.h>
-#include <str.h>
 #include "ext4/ops.h"
 #include "../../vfs/vfs.h"
@@ -73,5 +72,5 @@
 	}
 	
-	errno_t rc = ext4_global_init();
+	int rc = ext4_global_init();
 	if (rc != EOK) {
 		printf("%s: Global initialization failed\n", NAME);
Index: uspace/srv/fs/fat/fat.c
===================================================================
--- uspace/srv/fs/fat/fat.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/fat/fat.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -43,9 +43,7 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <task.h>
 #include <stdio.h>
 #include <libfs.h>
-#include <str.h>
 #include "../../vfs/vfs.h"
 
@@ -72,5 +70,5 @@
 	}
 
-	errno_t rc = fat_idx_init();
+	int rc = fat_idx_init();
 	if (rc != EOK)
 		goto err;
@@ -97,5 +95,5 @@
 	
 err:
-	printf(NAME ": Failed to register file system: %s\n", str_error(rc));
+	printf(NAME ": Failed to register file system (%d)\n", rc);
 	return rc;
 }
Index: uspace/srv/fs/fat/fat.h
===================================================================
--- uspace/srv/fs/fat/fat.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/fat/fat.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -250,5 +250,5 @@
 extern libfs_ops_t fat_libfs_ops;
 
-extern errno_t fat_idx_get_new(fat_idx_t **, service_id_t);
+extern int fat_idx_get_new(fat_idx_t **, service_id_t);
 extern fat_idx_t *fat_idx_get_by_pos(service_id_t, fat_cluster_t, unsigned);
 extern fat_idx_t *fat_idx_get_by_index(service_id_t, fs_index_t);
@@ -257,7 +257,7 @@
 extern void fat_idx_hashout(fat_idx_t *);
 
-extern errno_t fat_idx_init(void);
+extern int fat_idx_init(void);
 extern void fat_idx_fini(void);
-extern errno_t fat_idx_init_by_service_id(service_id_t);
+extern int fat_idx_init_by_service_id(service_id_t);
 extern void fat_idx_fini_by_service_id(service_id_t);
 
Index: uspace/srv/fs/fat/fat_directory.c
===================================================================
--- uspace/srv/fs/fat/fat_directory.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/fat/fat_directory.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -46,5 +46,5 @@
 #include <stdio.h>
 
-errno_t fat_directory_open(fat_node_t *nodep, fat_directory_t *di)
+int fat_directory_open(fat_node_t *nodep, fat_directory_t *di)
 {
 	di->b = NULL;
@@ -62,7 +62,7 @@
 }
 
-errno_t fat_directory_close(fat_directory_t *di)
-{
-	errno_t rc = EOK;
+int fat_directory_close(fat_directory_t *di)
+{
+	int rc = EOK;
 	
 	if (di->b)
@@ -72,8 +72,8 @@
 }
 
-static errno_t fat_directory_block_load(fat_directory_t *di)
+static int fat_directory_block_load(fat_directory_t *di)
 {
 	uint32_t i;
-	errno_t rc;
+	int rc;
 
 	i = (di->pos * sizeof(fat_dentry_t)) / BPS(di->bs);
@@ -98,7 +98,7 @@
 }
 
-errno_t fat_directory_next(fat_directory_t *di)
-{
-	errno_t rc;
+int fat_directory_next(fat_directory_t *di)
+{
+	int rc;
 
 	di->pos += 1;
@@ -110,7 +110,7 @@
 }
 
-errno_t fat_directory_prev(fat_directory_t *di)
-{
-	errno_t rc = EOK;
+int fat_directory_prev(fat_directory_t *di)
+{
+	int rc = EOK;
 	
 	if (di->pos > 0) {
@@ -126,8 +126,8 @@
 }
 
-errno_t fat_directory_seek(fat_directory_t *di, aoff64_t pos)
+int fat_directory_seek(fat_directory_t *di, aoff64_t pos)
 {
 	aoff64_t _pos = di->pos;
-	errno_t rc;
+	int rc;
 
 	di->pos = pos;
@@ -139,7 +139,7 @@
 }
 
-errno_t fat_directory_get(fat_directory_t *di, fat_dentry_t **d)
-{
-	errno_t rc;
+int fat_directory_get(fat_directory_t *di, fat_dentry_t **d)
+{
+	int rc;
 	
 	rc = fat_directory_block_load(di);
@@ -152,5 +152,5 @@
 }
 
-errno_t fat_directory_read(fat_directory_t *di, char *name, fat_dentry_t **de)
+int fat_directory_read(fat_directory_t *di, char *name, fat_dentry_t **de)
 {
 	fat_dentry_t *d = NULL;
@@ -160,5 +160,5 @@
 	int long_entry_count = 0;
 	uint8_t checksum = 0;
-	errno_t rc;
+	int rc;
 
 	void *data;
@@ -236,7 +236,7 @@
 }
 
-errno_t fat_directory_erase(fat_directory_t *di)
-{
-	errno_t rc;
+int fat_directory_erase(fat_directory_t *di)
+{
+	int rc;
 	fat_dentry_t *d;
 	bool flag = false;
@@ -267,7 +267,7 @@
 }
 
-errno_t fat_directory_write(fat_directory_t *di, const char *name, fat_dentry_t *de)
-{
-	errno_t rc;
+int fat_directory_write(fat_directory_t *di, const char *name, fat_dentry_t *de)
+{
+	int rc;
 	void *data;
 	fat_instance_t *instance;
@@ -348,5 +348,5 @@
 }
 
-errno_t fat_directory_create_sfn(fat_directory_t *di, fat_dentry_t *de,
+int fat_directory_create_sfn(fat_directory_t *di, fat_dentry_t *de,
     const char *lname)
 {
@@ -398,8 +398,8 @@
 }
 
-errno_t fat_directory_write_dentry(fat_directory_t *di, fat_dentry_t *de)
+int fat_directory_write_dentry(fat_directory_t *di, fat_dentry_t *de)
 {
 	fat_dentry_t *d;
-	errno_t rc;
+	int rc;
 
 	rc = fat_directory_get(di, &d);
@@ -412,7 +412,7 @@
 }
 
-errno_t fat_directory_expand(fat_directory_t *di)
-{
-	errno_t rc;
+int fat_directory_expand(fat_directory_t *di)
+{
+	int rc;
 	fat_cluster_t mcl, lcl;
 
@@ -444,10 +444,10 @@
 }
 
-errno_t fat_directory_lookup_free(fat_directory_t *di, size_t count)
+int fat_directory_lookup_free(fat_directory_t *di, size_t count)
 {
 	fat_dentry_t *d;
 	size_t found;
 	aoff64_t pos;
-	errno_t rc;
+	int rc;
 	
 	do {
@@ -485,5 +485,5 @@
 }
 
-errno_t fat_directory_lookup_name(fat_directory_t *di, const char *name,
+int fat_directory_lookup_name(fat_directory_t *di, const char *name,
     fat_dentry_t **de)
 {
@@ -506,5 +506,5 @@
 {
 	fat_dentry_t *d;
-	errno_t rc;
+	int rc;
 
 	fat_directory_seek(di, 0);
@@ -538,8 +538,8 @@
  * @return EOK on success, ENOENT if not found, EIO on I/O error
  */
-errno_t fat_directory_vollabel_get(fat_directory_t *di, char *label)
+int fat_directory_vollabel_get(fat_directory_t *di, char *label)
 {
 	fat_dentry_t *d;
-	errno_t rc;
+	int rc;
 
 	fat_directory_seek(di, 0);
Index: uspace/srv/fs/fat/fat_directory.h
===================================================================
--- uspace/srv/fs/fat/fat_directory.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/fat/fat_directory.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -29,5 +29,5 @@
 /** @addtogroup fs
  * @{
- */
+ */ 
 
 #ifndef FAT_FAT_DIRECTORY_H_
@@ -52,25 +52,25 @@
 
 
-extern errno_t fat_directory_open(fat_node_t *, fat_directory_t *);
-extern errno_t fat_directory_close(fat_directory_t *);
+extern int fat_directory_open(fat_node_t *, fat_directory_t *);
+extern int fat_directory_close(fat_directory_t *);
 
-extern errno_t fat_directory_next(fat_directory_t *);
-extern errno_t fat_directory_prev(fat_directory_t *);
-extern errno_t fat_directory_seek(fat_directory_t *, aoff64_t);
-extern errno_t fat_directory_get(fat_directory_t *, fat_dentry_t **);
+extern int fat_directory_next(fat_directory_t *);
+extern int fat_directory_prev(fat_directory_t *);
+extern int fat_directory_seek(fat_directory_t *, aoff64_t);
+extern int fat_directory_get(fat_directory_t *, fat_dentry_t **);
 
-extern errno_t fat_directory_read(fat_directory_t *, char *, fat_dentry_t **);
-extern errno_t fat_directory_write(fat_directory_t *, const char *, fat_dentry_t *);
-extern errno_t fat_directory_erase(fat_directory_t *);
-extern errno_t fat_directory_lookup_name(fat_directory_t *, const char *,
+extern int fat_directory_read(fat_directory_t *, char *, fat_dentry_t **);
+extern int fat_directory_write(fat_directory_t *, const char *, fat_dentry_t *);
+extern int fat_directory_erase(fat_directory_t *);
+extern int fat_directory_lookup_name(fat_directory_t *, const char *,
     fat_dentry_t **);
 extern bool fat_directory_is_sfn_exist(fat_directory_t *, fat_dentry_t *);
 
-extern errno_t fat_directory_lookup_free(fat_directory_t *, size_t);
-extern errno_t fat_directory_write_dentry(fat_directory_t *, fat_dentry_t *);
-extern errno_t fat_directory_create_sfn(fat_directory_t *, fat_dentry_t *,
+extern int fat_directory_lookup_free(fat_directory_t *, size_t);
+extern int fat_directory_write_dentry(fat_directory_t *, fat_dentry_t *);
+extern int fat_directory_create_sfn(fat_directory_t *, fat_dentry_t *,
     const char *);
-extern errno_t fat_directory_expand(fat_directory_t *);
-extern errno_t fat_directory_vollabel_get(fat_directory_t *, char *);
+extern int fat_directory_expand(fat_directory_t *);
+extern int fat_directory_vollabel_get(fat_directory_t *, char *);
 
 #endif
Index: uspace/srv/fs/fat/fat_fat.c
===================================================================
--- uspace/srv/fs/fat/fat_fat.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/fat/fat_fat.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -71,7 +71,7 @@
  * @param max_clusters	Maximum number of clusters to visit.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 fat_cluster_walk(fat_bs_t *bs, service_id_t service_id, fat_cluster_t firstc,
     fat_cluster_t *lastc, uint32_t *numc, uint32_t max_clusters)
@@ -80,5 +80,5 @@
 	fat_cluster_t clst = firstc, clst_last1 = FAT_CLST_LAST1(bs);
 	fat_cluster_t clst_bad = FAT_CLST_BAD(bs);
-	errno_t rc;
+	int rc;
 
 	if (firstc == FAT_CLST_RES0) {
@@ -121,7 +121,7 @@
  * @param flags		Flags passed to libblock.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 fat_block_get(block_t **block, struct fat_bs *bs, fat_node_t *nodep,
     aoff64_t bn, int flags)
@@ -130,5 +130,5 @@
 	fat_cluster_t currc = 0;
 	aoff64_t relbn = bn;
-	errno_t rc;
+	int rc;
 
 	if (!nodep->size)
@@ -186,7 +186,7 @@
  * @param flags		Flags passed to libblock.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 _fat_block_get(block_t **block, fat_bs_t *bs, service_id_t service_id,
     fat_cluster_t fcl, fat_cluster_t *clp, aoff64_t bn, int flags)
@@ -195,5 +195,5 @@
 	uint32_t max_clusters;
 	fat_cluster_t c = 0;
-	errno_t rc;
+	int rc;
 
 	/*
@@ -235,12 +235,12 @@
  * @param pos		Position in the last node block.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 fat_fill_gap(fat_bs_t *bs, fat_node_t *nodep, fat_cluster_t mcl, aoff64_t pos)
 {
 	block_t *b;
 	aoff64_t o, boundary;
-	errno_t rc;
+	int rc;
 
 	boundary = ROUND_UP(nodep->size, BPS(bs) * SPC(bs));
@@ -287,7 +287,7 @@
  * @param value		Output argument holding the value of the cluster.
  *
- * @return		EOK or an error code.
- */
-static errno_t
+ * @return		EOK or a negative error code.
+ */
+static int
 fat_get_cluster_fat12(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t *value)
@@ -296,5 +296,5 @@
 	uint16_t byte1, byte2;
 	aoff64_t offset;
-	errno_t rc;
+	int rc;
 
 	offset = (clst + clst / 2);
@@ -357,7 +357,7 @@
  * @param value		Output argument holding the value of the cluster.
  *
- * @return		EOK or an error code.
- */
-static errno_t
+ * @return		EOK or a negative error code.
+ */
+static int
 fat_get_cluster_fat16(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t *value)
@@ -365,5 +365,5 @@
 	block_t *b;
 	aoff64_t offset;
-	errno_t rc;
+	int rc;
 
 	offset = (clst * FAT16_CLST_SIZE);
@@ -388,7 +388,7 @@
  * @param value		Output argument holding the value of the cluster.
  *
- * @return		EOK or an error code.
- */
-static errno_t
+ * @return		EOK or a negative error code.
+ */
+static int
 fat_get_cluster_fat32(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t *value)
@@ -396,5 +396,5 @@
 	block_t *b;
 	aoff64_t offset;
-	errno_t rc;
+	int rc;
 
 	offset = (clst * FAT32_CLST_SIZE);
@@ -421,11 +421,11 @@
  * @param value		Output argument holding the value of the cluster.
  *
- * @return		EOK or an error code.
- */
-errno_t
+ * @return		EOK or a negative error code.
+ */
+int
 fat_get_cluster(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t *value)
 {
-	errno_t rc;
+	int rc;
 
 	assert(fatno < FATCNT(bs));
@@ -449,7 +449,7 @@
  * @param value		Value to set the cluster with.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t
+ * @return		EOK on success or a negative error code.
+ */
+static int
 fat_set_cluster_fat12(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t value)
@@ -458,5 +458,5 @@
 	aoff64_t offset;
 	uint16_t byte1, byte2;
-	errno_t rc;
+	int rc;
 
 	offset = (clst + clst / 2);
@@ -537,7 +537,7 @@
  * @param value		Value to set the cluster with.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t
+ * @return		EOK on success or a negative error code.
+ */
+static int
 fat_set_cluster_fat16(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t value)
@@ -545,5 +545,5 @@
 	block_t *b;
 	aoff64_t offset;
-	errno_t rc;
+	int rc;
 
 	offset = (clst * FAT16_CLST_SIZE);
@@ -570,7 +570,7 @@
  * @param value		Value to set the cluster with.
  *
- * @return		EOK on success or an error code.
- */
-static errno_t
+ * @return		EOK on success or a negative error code.
+ */
+static int
 fat_set_cluster_fat32(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t value)
@@ -578,5 +578,5 @@
 	block_t *b;
 	aoff64_t offset;
-	errno_t rc;
+	int rc;
 	fat_cluster_t temp;
 
@@ -607,11 +607,11 @@
  * @param value		Value to set the cluster with.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative error code.
+ */
+int
 fat_set_cluster(fat_bs_t *bs, service_id_t service_id, unsigned fatno,
     fat_cluster_t clst, fat_cluster_t value)
 {
-	errno_t rc;
+	int rc;
 
 	assert(fatno < FATCNT(bs));
@@ -634,7 +634,7 @@
  * @param nclsts	Number of clusters in the lifo chain.
  *
- * @return		EOK on success or an error code.
- */
-errno_t fat_alloc_shadow_clusters(fat_bs_t *bs, service_id_t service_id,
+ * @return		EOK on success or a negative error code.
+ */
+int fat_alloc_shadow_clusters(fat_bs_t *bs, service_id_t service_id,
     fat_cluster_t *lifo, unsigned nclsts)
 {
@@ -642,5 +642,5 @@
 	unsigned c;
 	fat_cluster_t clst_last1 = FAT_CLST_LAST1(bs);
-	errno_t rc;
+	int rc;
 
 	for (fatno = FAT1 + 1; fatno < FATCNT(bs); fatno++) {
@@ -671,7 +671,7 @@
  *			will be returned.
  *
- * @return		EOK on success, an error code otherwise.
- */
-errno_t
+ * @return		EOK on success, a negative error code otherwise.
+ */
+int
 fat_alloc_clusters(fat_bs_t *bs, service_id_t service_id, unsigned nclsts,
     fat_cluster_t *mcl, fat_cluster_t *lcl)
@@ -682,5 +682,5 @@
 	fat_cluster_t value = 0;
 	fat_cluster_t clst_last1 = FAT_CLST_LAST1(bs);
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	lifo = (fat_cluster_t *) malloc(nclsts * sizeof(fat_cluster_t));
@@ -742,7 +742,7 @@
  * @param firstc	First cluster in the chain which is to be freed.
  *
- * @return		EOK on success or an error code.
- */
-errno_t
+ * @return		EOK on success or a negative return code.
+ */
+int
 fat_free_clusters(fat_bs_t *bs, service_id_t service_id, fat_cluster_t firstc)
 {
@@ -750,5 +750,5 @@
 	fat_cluster_t nextc = 0;
 	fat_cluster_t clst_bad = FAT_CLST_BAD(bs);
-	errno_t rc;
+	int rc;
 
 	/* Mark all clusters in the chain as free in all copies of FAT. */
@@ -780,7 +780,7 @@
  * @param lcl		Last cluster of the cluster chain to append.
  *
- * @return		EOK on success or an error code.
- */
-errno_t fat_append_clusters(fat_bs_t *bs, fat_node_t *nodep, fat_cluster_t mcl,
+ * @return		EOK on success or a negative error code.
+ */
+int fat_append_clusters(fat_bs_t *bs, fat_node_t *nodep, fat_cluster_t mcl,
     fat_cluster_t lcl)
 {
@@ -788,5 +788,5 @@
 	fat_cluster_t lastc = 0;
 	uint8_t fatno;
-	errno_t rc;
+	int rc;
 
 	if (nodep->firstc == FAT_CLST_RES0) {
@@ -827,10 +827,10 @@
  *			be chopped off.
  *
- * @return		EOK on success or an error code.
- */
-errno_t fat_chop_clusters(fat_bs_t *bs, fat_node_t *nodep, fat_cluster_t lcl)
+ * @return		EOK on success or a negative return code.
+ */
+int fat_chop_clusters(fat_bs_t *bs, fat_node_t *nodep, fat_cluster_t lcl)
 {
 	fat_cluster_t clst_last1 = FAT_CLST_LAST1(bs);
-	errno_t rc;
+	int rc;
 	service_id_t service_id = nodep->idx->service_id;
 
@@ -880,10 +880,10 @@
 }
 
-errno_t
+int
 fat_zero_cluster(struct fat_bs *bs, service_id_t service_id, fat_cluster_t c)
 {
 	int i;
 	block_t *b;
-	errno_t rc;
+	int rc;
 
 	for (i = 0; i < SPC(bs); i++) {
@@ -908,10 +908,10 @@
  * does not contain a fat file system.
  */
-errno_t fat_sanity_check(fat_bs_t *bs, service_id_t service_id)
+int fat_sanity_check(fat_bs_t *bs, service_id_t service_id)
 {
 	fat_cluster_t e0 = 0;
 	fat_cluster_t e1 = 0;
 	unsigned fat_no;
-	errno_t rc;
+	int rc;
 
 	/* Check number of FATs. */
Index: uspace/srv/fs/fat/fat_fat.h
===================================================================
--- uspace/srv/fs/fat/fat_fat.h	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/fat/fat_fat.h	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -108,29 +108,29 @@
 #define fat_clusters_get(numc, bs, sid, fc) \
     fat_cluster_walk((bs), (sid), (fc), NULL, (numc), (uint32_t) -1)
-extern errno_t fat_cluster_walk(struct fat_bs *, service_id_t, fat_cluster_t,
+extern int fat_cluster_walk(struct fat_bs *, service_id_t, fat_cluster_t,
     fat_cluster_t *, uint32_t *, uint32_t);
 
-extern errno_t fat_block_get(block_t **, struct fat_bs *, struct fat_node *,
+extern int fat_block_get(block_t **, struct fat_bs *, struct fat_node *,
     aoff64_t, int);
-extern errno_t _fat_block_get(block_t **, struct fat_bs *, service_id_t,
+extern int _fat_block_get(block_t **, struct fat_bs *, service_id_t,
     fat_cluster_t, fat_cluster_t *, aoff64_t, int);
 
-extern errno_t fat_append_clusters(struct fat_bs *, struct fat_node *,
+extern int fat_append_clusters(struct fat_bs *, struct fat_node *,
     fat_cluster_t, fat_cluster_t);
-extern errno_t fat_chop_clusters(struct fat_bs *, struct fat_node *,
+extern int fat_chop_clusters(struct fat_bs *, struct fat_node *,
     fat_cluster_t);
-extern errno_t fat_alloc_clusters(struct fat_bs *, service_id_t, unsigned,
+extern int fat_alloc_clusters(struct fat_bs *, service_id_t, unsigned,
     fat_cluster_t *, fat_cluster_t *);
-extern errno_t fat_free_clusters(struct fat_bs *, service_id_t, fat_cluster_t);
-extern errno_t fat_alloc_shadow_clusters(struct fat_bs *, service_id_t,
+extern int fat_free_clusters(struct fat_bs *, service_id_t, fat_cluster_t);
+extern int fat_alloc_shadow_clusters(struct fat_bs *, service_id_t,
     fat_cluster_t *, unsigned);
-extern errno_t fat_get_cluster(struct fat_bs *, service_id_t, unsigned,
+extern int fat_get_cluster(struct fat_bs *, service_id_t, unsigned,
     fat_cluster_t, fat_cluster_t *);
-extern errno_t fat_set_cluster(struct fat_bs *, service_id_t, unsigned,
+extern int fat_set_cluster(struct fat_bs *, service_id_t, unsigned,
     fat_cluster_t, fat_cluster_t);
-extern errno_t fat_fill_gap(struct fat_bs *, struct fat_node *, fat_cluster_t,
+extern int fat_fill_gap(struct fat_bs *, struct fat_node *, fat_cluster_t,
     aoff64_t);
-extern errno_t fat_zero_cluster(struct fat_bs *, service_id_t, fat_cluster_t);
-extern errno_t fat_sanity_check(struct fat_bs *, service_id_t);
+extern int fat_zero_cluster(struct fat_bs *, service_id_t, fat_cluster_t);
+extern int fat_sanity_check(struct fat_bs *, service_id_t);
 
 #endif
Index: uspace/srv/fs/fat/fat_idx.c
===================================================================
--- uspace/srv/fs/fat/fat_idx.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/fat/fat_idx.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -328,5 +328,5 @@
 }
 
-static errno_t fat_idx_create(fat_idx_t **fidxp, service_id_t service_id)
+static int fat_idx_create(fat_idx_t **fidxp, service_id_t service_id)
 {
 	fat_idx_t *fidx;
@@ -350,8 +350,8 @@
 }
 
-errno_t fat_idx_get_new(fat_idx_t **fidxp, service_id_t service_id)
+int fat_idx_get_new(fat_idx_t **fidxp, service_id_t service_id)
 {
 	fat_idx_t *fidx;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&used_lock);
@@ -386,5 +386,5 @@
 		fidx = hash_table_get_inst(l, fat_idx_t, uph_link);
 	} else {
-		errno_t rc;
+		int rc;
 
 		rc = fat_idx_create(&fidx, service_id);
@@ -467,5 +467,5 @@
 }
 
-errno_t fat_idx_init(void)
+int fat_idx_init(void)
 {
 	if (!hash_table_create(&up_hash, 0, 0, &uph_ops)) 
@@ -486,8 +486,8 @@
 }
 
-errno_t fat_idx_init_by_service_id(service_id_t service_id)
+int fat_idx_init_by_service_id(service_id_t service_id)
 {
 	unused_t *u;
-	errno_t rc = EOK;
+	int rc = EOK;
 
 	u = (unused_t *) malloc(sizeof(unused_t));
Index: uspace/srv/fs/fat/fat_ops.c
===================================================================
--- uspace/srv/fs/fat/fat_ops.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/fat/fat_ops.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -73,14 +73,14 @@
  * Forward declarations of FAT libfs operations.
  */
-static errno_t fat_root_get(fs_node_t **, service_id_t);
-static errno_t fat_match(fs_node_t **, fs_node_t *, const char *);
-static errno_t fat_node_get(fs_node_t **, service_id_t, fs_index_t);
-static errno_t fat_node_open(fs_node_t *);
-static errno_t fat_node_put(fs_node_t *);
-static errno_t fat_create_node(fs_node_t **, service_id_t, int);
-static errno_t fat_destroy_node(fs_node_t *);
-static errno_t fat_link(fs_node_t *, fs_node_t *, const char *);
-static errno_t fat_unlink(fs_node_t *, fs_node_t *, const char *);
-static errno_t fat_has_children(bool *, fs_node_t *);
+static int fat_root_get(fs_node_t **, service_id_t);
+static int fat_match(fs_node_t **, fs_node_t *, const char *);
+static int fat_node_get(fs_node_t **, service_id_t, fs_index_t);
+static int fat_node_open(fs_node_t *);
+static int fat_node_put(fs_node_t *);
+static int fat_create_node(fs_node_t **, service_id_t, int);
+static int fat_destroy_node(fs_node_t *);
+static int fat_link(fs_node_t *, fs_node_t *, const char *);
+static int fat_unlink(fs_node_t *, fs_node_t *, const char *);
+static int fat_has_children(bool *, fs_node_t *);
 static fs_index_t fat_index_get(fs_node_t *);
 static aoff64_t fat_size_get(fs_node_t *);
@@ -89,7 +89,7 @@
 static bool fat_is_file(fs_node_t *node);
 static service_id_t fat_service_get(fs_node_t *node);
-static errno_t fat_size_block(service_id_t, uint32_t *);
-static errno_t fat_total_block_count(service_id_t, uint64_t *);
-static errno_t fat_free_block_count(service_id_t, uint64_t *);
+static int fat_size_block(service_id_t, uint32_t *);
+static int fat_total_block_count(service_id_t, uint64_t *);
+static int fat_free_block_count(service_id_t, uint64_t *);
 
 /*
@@ -114,10 +114,10 @@
 }
 
-static errno_t fat_node_sync(fat_node_t *node)
+static int fat_node_sync(fat_node_t *node)
 {
 	block_t *b;
 	fat_bs_t *bs;
 	fat_dentry_t *d;
-	errno_t rc;
+	int rc;
 
 	assert(node->dirty);
@@ -148,7 +148,7 @@
 }
 
-static errno_t fat_node_fini_by_service_id(service_id_t service_id)
-{
-	errno_t rc;
+static int fat_node_fini_by_service_id(service_id_t service_id)
+{
+	int rc;
 
 	/*
@@ -204,9 +204,9 @@
 }
 
-static errno_t fat_node_get_new(fat_node_t **nodepp)
+static int fat_node_get_new(fat_node_t **nodepp)
 {
 	fs_node_t *fn;
 	fat_node_t *nodep;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&ffn_mutex);
@@ -266,5 +266,5 @@
  * @param idxp		Locked index structure.
  */
-static errno_t fat_node_get_core(fat_node_t **nodepp, fat_idx_t *idxp)
+static int fat_node_get_core(fat_node_t **nodepp, fat_idx_t *idxp)
 {
 	block_t *b;
@@ -272,5 +272,5 @@
 	fat_dentry_t *d;
 	fat_node_t *nodep = NULL;
-	errno_t rc;
+	int rc;
 
 	if (idxp->nodep) {
@@ -365,10 +365,10 @@
  */
 
-errno_t fat_root_get(fs_node_t **rfn, service_id_t service_id)
+int fat_root_get(fs_node_t **rfn, service_id_t service_id)
 {
 	return fat_node_get(rfn, service_id, 0);
 }
 
-errno_t fat_match(fs_node_t **rfn, fs_node_t *pfn, const char *component)
+int fat_match(fs_node_t **rfn, fs_node_t *pfn, const char *component)
 {
 	fat_node_t *parentp = FAT_NODE(pfn);
@@ -376,5 +376,5 @@
 	fat_dentry_t *d;
 	service_id_t service_id;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&parentp->idx->lock);
@@ -426,9 +426,9 @@
 
 /** Instantiate a FAT in-core node. */
-errno_t fat_node_get(fs_node_t **rfn, service_id_t service_id, fs_index_t index)
+int fat_node_get(fs_node_t **rfn, service_id_t service_id, fs_index_t index)
 {
 	fat_node_t *nodep;
 	fat_idx_t *idxp;
-	errno_t rc;
+	int rc;
 
 	idxp = fat_idx_get_by_index(service_id, index);
@@ -445,5 +445,5 @@
 }
 
-errno_t fat_node_open(fs_node_t *fn)
+int fat_node_open(fs_node_t *fn)
 {
 	/*
@@ -454,5 +454,5 @@
 }
 
-errno_t fat_node_put(fs_node_t *fn)
+int fat_node_put(fs_node_t *fn)
 {
 	fat_node_t *nodep = FAT_NODE(fn);
@@ -483,5 +483,5 @@
 }
 
-errno_t fat_create_node(fs_node_t **rfn, service_id_t service_id, int flags)
+int fat_create_node(fs_node_t **rfn, service_id_t service_id, int flags)
 {
 	fat_idx_t *idxp;
@@ -489,5 +489,5 @@
 	fat_bs_t *bs;
 	fat_cluster_t mcl, lcl;
-	errno_t rc;
+	int rc;
 
 	bs = block_bb_get(service_id);
@@ -538,10 +538,10 @@
 }
 
-errno_t fat_destroy_node(fs_node_t *fn)
+int fat_destroy_node(fs_node_t *fn)
 {
 	fat_node_t *nodep = FAT_NODE(fn);
 	fat_bs_t *bs;
 	bool has_children;
-	errno_t rc;
+	int rc;
 
 	/*
@@ -575,5 +575,5 @@
 }
 
-errno_t fat_link(fs_node_t *pfn, fs_node_t *cfn, const char *name)
+int fat_link(fs_node_t *pfn, fs_node_t *cfn, const char *name)
 {
 	fat_node_t *parentp = FAT_NODE(pfn);
@@ -584,5 +584,5 @@
 	fat_directory_t di;
 	fat_dentry_t de;
-	errno_t rc;
+	int rc;
 
 	fibril_mutex_lock(&childp->lock);
@@ -696,10 +696,10 @@
 }
 
-errno_t fat_unlink(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
+int fat_unlink(fs_node_t *pfn, fs_node_t *cfn, const char *nm)
 {
 	fat_node_t *parentp = FAT_NODE(pfn);
 	fat_node_t *childp = FAT_NODE(cfn);
 	bool has_children;
-	errno_t rc;
+	int rc;
 
 	if (!parentp)
@@ -753,5 +753,5 @@
 }
 
-errno_t fat_has_children(bool *has_children, fs_node_t *fn)
+int fat_has_children(bool *has_children, fs_node_t *fn)
 {
 	fat_bs_t *bs;
@@ -760,5 +760,5 @@
 	block_t *b;
 	unsigned i, j;
-	errno_t rc;
+	int rc;
 
 	if (nodep->type != FAT_DIRECTORY) {
@@ -843,5 +843,5 @@
 }
 
-errno_t fat_size_block(service_id_t service_id, uint32_t *size)
+int fat_size_block(service_id_t service_id, uint32_t *size)
 {
 	fat_bs_t *bs;
@@ -853,5 +853,5 @@
 }
 
-errno_t fat_total_block_count(service_id_t service_id, uint64_t *count)
+int fat_total_block_count(service_id_t service_id, uint64_t *count)
 {
 	fat_bs_t *bs;
@@ -863,10 +863,10 @@
 }
 
-errno_t fat_free_block_count(service_id_t service_id, uint64_t *count)
+int fat_free_block_count(service_id_t service_id, uint64_t *count)
 {
 	fat_bs_t *bs;
 	fat_cluster_t e0;
 	uint64_t block_count;
-	errno_t rc;
+	int rc;
 	uint32_t cluster_no, clusters;
 
@@ -910,9 +910,9 @@
 };
 
-static errno_t fat_fs_open(service_id_t service_id, enum cache_mode cmode,
+static int fat_fs_open(service_id_t service_id, enum cache_mode cmode,
     fs_node_t **rrfn, fat_idx_t **rridxp)
 {
 	fat_bs_t *bs;
-	errno_t rc;
+	int rc;
 
 	/* initialize libblock */
@@ -1037,5 +1037,5 @@
  */
 
-static errno_t fat_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
+static int fat_fsprobe(service_id_t service_id, vfs_fs_probe_info_t *info)
 {
 	fat_idx_t *ridxp;
@@ -1044,5 +1044,5 @@
 	fat_directory_t di;
 	char label[FAT_VOLLABEL_LEN + 1];
-	errno_t rc;
+	int rc;
 
 	rc = fat_fs_open(service_id, CACHE_MODE_WT, &rfn, &ridxp);
@@ -1076,5 +1076,5 @@
 }
 
-static errno_t
+static int
 fat_mounted(service_id_t service_id, const char *opts, fs_index_t *index,
     aoff64_t *size)
@@ -1084,5 +1084,5 @@
 	fat_idx_t *ridxp;
 	fs_node_t *rfn;
-	errno_t rc;
+	int rc;
 
 	instance = malloc(sizeof(fat_instance_t));
@@ -1125,10 +1125,10 @@
 }
 
-static errno_t fat_update_fat32_fsinfo(service_id_t service_id)
+static int fat_update_fat32_fsinfo(service_id_t service_id)
 {
 	fat_bs_t *bs;
 	fat32_fsinfo_t *info;
 	block_t *b;
-	errno_t rc;
+	int rc;
 
 	bs = block_bb_get(service_id);
@@ -1156,10 +1156,10 @@
 }
 
-static errno_t fat_unmounted(service_id_t service_id)
+static int fat_unmounted(service_id_t service_id)
 {
 	fs_node_t *fn;
 	fat_node_t *nodep;
 	fat_bs_t *bs;
-	errno_t rc;
+	int rc;
 
 	bs = block_bb_get(service_id);
@@ -1208,5 +1208,5 @@
 }
 
-static errno_t
+static int
 fat_read(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *rbytes)
@@ -1217,5 +1217,5 @@
 	size_t bytes;
 	block_t *b;
-	errno_t rc;
+	int rc;
 
 	rc = fat_node_get(&fn, service_id, index);
@@ -1318,5 +1318,5 @@
 }
 
-static errno_t
+static int
 fat_write(service_id_t service_id, fs_index_t index, aoff64_t pos,
     size_t *wbytes, aoff64_t *nsize)
@@ -1329,5 +1329,5 @@
 	aoff64_t boundary;
 	int flags = BLOCK_FLAGS_NONE;
-	errno_t rc;
+	int rc;
 	
 	rc = fat_node_get(&fn, service_id, index);
@@ -1455,5 +1455,5 @@
 }
 
-static errno_t
+static int
 fat_truncate(service_id_t service_id, fs_index_t index, aoff64_t size)
 {
@@ -1461,5 +1461,5 @@
 	fat_node_t *nodep;
 	fat_bs_t *bs;
-	errno_t rc;
+	int rc;
 
 	rc = fat_node_get(&fn, service_id, index);
@@ -1514,14 +1514,14 @@
 }
 
-static errno_t fat_close(service_id_t service_id, fs_index_t index)
-{
-	return EOK;
-}
-
-static errno_t fat_destroy(service_id_t service_id, fs_index_t index)
+static int fat_close(service_id_t service_id, fs_index_t index)
+{
+	return EOK;
+}
+
+static int fat_destroy(service_id_t service_id, fs_index_t index)
 {
 	fs_node_t *fn;
 	fat_node_t *nodep;
-	errno_t rc;
+	int rc;
 
 	rc = fat_node_get(&fn, service_id, index);
@@ -1542,8 +1542,8 @@
 }
 
-static errno_t fat_sync(service_id_t service_id, fs_index_t index)
+static int fat_sync(service_id_t service_id, fs_index_t index)
 {
 	fs_node_t *fn;
-	errno_t rc = fat_node_get(&fn, service_id, index);
+	int rc = fat_node_get(&fn, service_id, index);
 	if (rc != EOK)
 		return rc;
Index: uspace/srv/fs/locfs/locfs.c
===================================================================
--- uspace/srv/fs/locfs/locfs.c	(revision a912afff2183b03ff0125b2f2bfcbf5235fc78c7)
+++ uspace/srv/fs/locfs/locfs.c	(revision 220adfa40192f4969d92a5de29826f012343ae2a)
@@ -44,8 +44,6 @@
 #include <async.h>
 #include <errno.h>
-#include <str_error.h>
 #include <task.h>
 #include <libfs.h>
-#include <str.h>
 #include "locfs.h"
 #include "locfs_ops.h"
@@ -86,8 +84,8 @@
 	}
 	
-	errno_t rc = fs_register(vfs_sess, &locfs_vfs_info, &locfs_ops,
+	int rc = fs_register(vfs_sess, &locfs_vfs_info, &locfs_ops,
 	    &locfs_libfs_ops);
 	if (rc != EOK) {
-		printf("%s: Failed to register file system: %s\n", NAME, str_error(rc));
+		printf("%s: Failed to register file system (%d)\n", NAME, rc);
 		return rc;
 	}
